const path = require('path');
import * as fs from "fs";
import { BizError } from "../util/bizError";
import { analysisXml } from "../util/myXML";
import { ServerConfig } from "../config/systemClass";
const os = require('os');

export let systemConfig =  new ServerConfig;

const ConfigName = "serverConfig.xml";
export async function initConfig() {
    try {
        let buff = fs.readFileSync(path.join(__dirname.substring(0,__dirname.indexOf("out")), ConfigName));
        let configStr = buff.toString();
        let configInfo:any = await analysisXml(configStr);
		if (!configInfo || !configInfo.config) throw new BizError('xml中无配置');
		else {
            
            let {port, dbConfig } = configInfo.config;
            systemConfig.port = parseInt(port[0]);

            if (dbConfig) {
                let dbConfigInfo = dbConfig[0];
                if (dbConfigInfo.mysqlHost && dbConfigInfo.mysqlPort && dbConfigInfo.mysqlUser && dbConfigInfo.dataBase) {
                    systemConfig.mysqlHost=dbConfigInfo.mysqlHost[0];
                    systemConfig.mysqlPort=parseInt(dbConfigInfo.mysqlPort[0]);
                    systemConfig.mysqlUser=dbConfigInfo.mysqlUser[0];
                    systemConfig.mysqlPwd=dbConfigInfo.mysqlPwd[0] || "";
                    systemConfig.dataBase=dbConfigInfo.dataBase[0];
                }
            }
		}
        
        console.log("config init success");

    } catch(err) {
        throw new BizError("服务器配置解析错误 请检查根目录下 serverConfig.xml 文件是否正确");
    }
}

function analysisMongoConnectStr(path, port, dataBase, w, timeOutMs) {
    return `mongodb://${path}:${port}/${dataBase}?w=${w}&wtimeoutMS=${timeOutMs}`
}
 
export function getEnum() {
    
}